
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class LotsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const lots = await db.lots.create(
            {
                id: data.id || undefined,
        
        lot_number: data.lot_number
        ||
        null
            ,
            
        supplier_lot_number: data.supplier_lot_number
        ||
        null
            ,
            
        received_at: data.received_at
        ||
        null
            ,
            
        manufactured_at: data.manufactured_at
        ||
        null
            ,
            
        expiry_at: data.expiry_at
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        quantity_received: data.quantity_received
        ||
        null
            ,
            
        quantity_available: data.quantity_available
        ||
        null
            ,
            
        uom: data.uom
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await lots.setCompany( data.company || null, {
            transaction,
        });
        
        await lots.setItem( data.item || null, {
            transaction,
        });
        
        await lots.setSupplier( data.supplier || null, {
            transaction,
        });
        
        await lots.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.lots.getTableName(),
                belongsToColumn: 'coa_documents',
                belongsToId: lots.id,
            },
            data.coa_documents,
            options,
        );
        

        return lots;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const lotsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                lot_number: item.lot_number
            ||
            null
            ,
            
                supplier_lot_number: item.supplier_lot_number
            ||
            null
            ,
            
                received_at: item.received_at
            ||
            null
            ,
            
                manufactured_at: item.manufactured_at
            ||
            null
            ,
            
                expiry_at: item.expiry_at
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                quantity_received: item.quantity_received
            ||
            null
            ,
            
                quantity_available: item.quantity_available
            ||
            null
            ,
            
                uom: item.uom
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const lots = await db.lots.bulkCreate(lotsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < lots.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.lots.getTableName(),
                    belongsToColumn: 'coa_documents',
                    belongsToId: lots[i].id,
                },
                data[i].coa_documents,
                options,
            );
        }
        

        return lots;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const lots = await db.lots.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.lot_number !== undefined) updatePayload.lot_number = data.lot_number;
        
        
        if (data.supplier_lot_number !== undefined) updatePayload.supplier_lot_number = data.supplier_lot_number;
        
        
        if (data.received_at !== undefined) updatePayload.received_at = data.received_at;
        
        
        if (data.manufactured_at !== undefined) updatePayload.manufactured_at = data.manufactured_at;
        
        
        if (data.expiry_at !== undefined) updatePayload.expiry_at = data.expiry_at;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.quantity_received !== undefined) updatePayload.quantity_received = data.quantity_received;
        
        
        if (data.quantity_available !== undefined) updatePayload.quantity_available = data.quantity_available;
        
        
        if (data.uom !== undefined) updatePayload.uom = data.uom;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await lots.update(updatePayload, {transaction});

        
        
        if (data.company !== undefined) {
            await lots.setCompany(
              
              data.company,
              
              { transaction }
            );
        }
        
        if (data.item !== undefined) {
            await lots.setItem(
              
              data.item,
              
              { transaction }
            );
        }
        
        if (data.supplier !== undefined) {
            await lots.setSupplier(
              
              data.supplier,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await lots.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.lots.getTableName(),
                belongsToColumn: 'coa_documents',
                belongsToId: lots.id,
            },
            data.coa_documents,
            options,
        );
        

        return lots;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const lots = await db.lots.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of lots) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of lots) {
                await record.destroy({transaction});
            }
        });


        return lots;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const lots = await db.lots.findByPk(id, options);

        await lots.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await lots.destroy({
            transaction
        });

        return lots;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const lots = await db.lots.findOne(
            { where },
            { transaction },
        );

        if (!lots) {
            return lots;
        }

        const output = lots.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.inventory_balances_lot = await lots.getInventory_balances_lot({
            transaction
        });
        
        
        output.inventory_transactions_lot = await lots.getInventory_transactions_lot({
            transaction
        });
        
        
        
        
        
        
        output.material_issues_lot = await lots.getMaterial_issues_lot({
            transaction
        });
        
        
        output.production_lots_lot = await lots.getProduction_lots_lot({
            transaction
        });
        
        
        
        
        output.qa_inspections_lot = await lots.getQa_inspections_lot({
            transaction
        });
        
        
        
        output.nonconformances_lot = await lots.getNonconformances_lot({
            transaction
        });
        
        
        
        
        
        
        output.company = await lots.getCompany({
            transaction
        });
        
        
        output.item = await lots.getItem({
            transaction
        });
        
        
        output.supplier = await lots.getSupplier({
            transaction
        });
        
        
        output.coa_documents = await lots.getCoa_documents({
            transaction
        });
        
        
        output.organizations = await lots.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.companies,
        as: 'company',
        
        where: filter.company ? {
          [Op.or]: [
            { id: { [Op.in]: filter.company.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.company.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.items,
        as: 'item',
        
        where: filter.item ? {
          [Op.or]: [
            { id: { [Op.in]: filter.item.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.item.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.suppliers,
        as: 'supplier',
        
        where: filter.supplier ? {
          [Op.or]: [
            { id: { [Op.in]: filter.supplier.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.supplier.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'coa_documents',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.lot_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'lots',
                        'lot_number',
                        filter.lot_number,
                    ),
                };
            }
            
            if (filter.supplier_lot_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'lots',
                        'supplier_lot_number',
                        filter.supplier_lot_number,
                    ),
                };
            }
            
            if (filter.uom) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'lots',
                        'uom',
                        filter.uom,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'lots',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.received_atRange) {
                const [start, end] = filter.received_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    received_at: {
                    ...where.received_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    received_at: {
                    ...where.received_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.manufactured_atRange) {
                const [start, end] = filter.manufactured_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    manufactured_at: {
                    ...where.manufactured_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    manufactured_at: {
                    ...where.manufactured_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.expiry_atRange) {
                const [start, end] = filter.expiry_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    expiry_at: {
                    ...where.expiry_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    expiry_at: {
                    ...where.expiry_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.quantity_receivedRange) {
                const [start, end] = filter.quantity_receivedRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    quantity_received: {
                    ...where.quantity_received,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    quantity_received: {
                    ...where.quantity_received,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.quantity_availableRange) {
                const [start, end] = filter.quantity_availableRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    quantity_available: {
                    ...where.quantity_available,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    quantity_available: {
                    ...where.quantity_available,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.lots.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'lots',
                        'lot_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.lots.findAll({
            attributes: [ 'id', 'lot_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['lot_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.lot_number,
        }));
    }

    
};

